#version 400

#include "/Lib/HDR.glsl"

#define TEMPERATURE 1.0 // [0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]

varying vec4 position;
varying float stars;

uniform sampler2D gaux4;

uniform int worldTime;

uniform float rainStrength;
uniform float screenBrightness;
uniform float nightVision;

#include "/Lib/TimeArray.glsl"

float starIntensity(vec3 pos) {
    float noise = fract(sin(dot(pos.xy, vec2(12.9898, 78.233))) * 43758.5453);
    return step(0.995, noise) * 1.0; // Erhöht die Wahrscheinlichkeit für sichtbare Sterne
}

void main() {
  vec3 skybox = vec3(0.0);
       skybox = mix(skybox, skybox * vec3(0.0, 0.5, 1.0), (1.0 - TEMPERATURE) * 0.25);
       skybox = pow(skybox, vec3(1.3)) / MAX_COLOR_RANGE;

  // Sterne hinzufügen
  float starBrightness = starIntensity(position.xyz) * (1.0 - rainStrength) * (1.0 - nightVision);
  vec3 starsColor = vec3(starBrightness);
  skybox += starsColor;

/* DRAWBUFFERS:061 */

  gl_FragData[0] = vec4(skybox, 1.0 - stars);
  gl_FragData[1] = vec4(skybox, 1.0 - stars);
  gl_FragData[2] = vec4(0.0, 0.0, 0.0, 1.0);
}